#!/usr/bin/env node

var ARI_HOST = '127.0.0.1';
var ARI_PORT = '8088';
var API_KEY = 'ariuser'+':'+ '123';
var APP_NAME = 'dialer';
//var BRIDGE_ID = '1000';
//var CHANNEL_ID = '2000';
//var PLAYBACK_ID = '6900';
var CONTEXT = 'users';
var TIMER = '30';
var FORMAT = 'alaw,ulaw';
var MEDIA = 'sound:paul_m';
//var MEDIA = 'sound:sh_11';
var MEDIA = 'sound:paul_bangles';
var SKIPMS = '3000';
var MIN =2000;
var MAX =2999;


var delay = require('delay');

var mysql = require('mysql');
var conn = mysql.createConnection({
host:'localhost',
port: '3306',
user:'crm',
password:'crm',
database:'crm',
charset: 'utf8'
});


 conn.connect(function(err){
    if (err) {
      return console.error("Ошибка: " + err.message);
    }
    else{
      console.log("Подключение к серверу MySQL успешно установлено");
    }
 });

/*
conn.query('SELECT * FROM info_clients', function(error, result, fields){

    console.log(result);
    console.log(result[1].name);

});
*/

//conn.query('select * ' );


/*
// закрытие подключения
 conn.end(function(err) {
  if (err) {
    return console.log("Ошибка: " + err.message);
  }
  console.log("Подключение закрыто");
});
//немедленное закрытие
conn.destroy()
*/





var WebSocket = require('ws');
var WebSocketServer = require('ws').Server;
var request = require('request');
var ws = new WebSocket( 'ws://' + ARI_HOST + ':' + ARI_PORT + '/ari/events?app=' + APP_NAME + '&api_key=' + API_KEY );
var wss;
var moh_chan;

var WSS_PORT='9088';
//wss = new WebSocketServer({ port: WSS_PORT});
var clients ={};


var uid ={};
var rnd ; 
var ep;

var tmp;
var ticket_stasis = []; // объявление массива



class Ticket_Stasis{
 //var trunk = new Array();	
 constructor(channel_id_b,channel_id_a,channel_name_a,calling_name,calling_number,called_number,trunk) { 
 this.bridge_number = channel_id_b - 1000; 
 this.channel_id_a  = channel_id_a;
 this.channel_name_a = channel_name_a;
 this.calling_name =  calling_name;
 this.calling_number = calling_number
 this.channel_id_b = channel_id_b;
 this.called_number = called_number;
 this.endp_tech =null;
 this.playback_channel_id_a = channel_id_b + 4000;
 this.playback_channel_id_b = channel_id_b + 7000;
 this.snoop_channel_id_a = channel_id_b + 1000;
 this.snoop_channel_id_b = channel_id_b + 2000;
 this.ring_kpv_to_a =true;
 this.ring_kpv_to_b =false;
 this.hangup_from_a = false; // On
 this.hangup_from_b = true;  // Off
 this.ticket_state = true;  
 this.trunk  = trunk;
 this.count_trying = 0;
 this.client_info ='';
 this.showcase = 'StasisStart'; 
 }

// геттер
/*
  get fullName() {
    return `${this.firstName} ${this.lastName}`;
  }
    // сеттер
  set fullName(newValue) {
    [this.firstName, this.lastName] = newValue.split(' ');
  }

  // вычисляемое название метода
  ["test".toUpperCase()]() {
    alert("PASSED!");
  }
 */ 
 get trunks()   { return `${this.trunk}`;  }
 get ui()   {    return `${this.bridge_number}`;  }
 get ch_a() {    return `${this.channel_id_a}`;  }
 get ch_b() {    return `${this.channel_id_b}`;  }
 get playback_ch_a() {    return `${this.playback_channel_id_a}`;  }
 get playback_ch_b() {    return `${this.playback_channel_id_b}`;  }
 get snoop_ch_a() {    return `${this.snoop_channel_id_a}`;  }
 get snoop_ch_b() {    return `${this.snoop_channel_id_b}`;  }
 
 get cdn () {    return `${this.called_number}`;  }
 get cgn () {    return `${this.calling_number}`;  }

 get ring_kpv_goto_a () {    return `${this.ring_kpv_to_a}`;  }
 get ring_kpv_goto_b () {    return `${this.ring_kpv_to_b}`;  }
 get hangup_status_a () {    return `${this.hangup_from_a}`;  }
 get hangup_status_b () {    return `${this.hangup_from_b}`;  }
 get ticket_status()    {    return `${this.ticket_state}`;  }
 get info() { return `${this.client_info}`;  }            
 get show_case()    {    return `${this.showcase}`;  }
 get cnt_try() {    return `${this.count_trying}`;   }
 get ep() {    return `${this.endp_tech}`;   }
 
 
 set ep(v) {   this.endp_tech = v;   }
 set cnt_try(v) {   this.count_trying = v;   }
 set trunks(v)   { this.trunk = v; }
 set ch_a(v) { this.channel_id_a = v; }
 set ch_b(v) { this.channel_id_b = v; }
 set ring_kpv_goto_a (v) {    this.ring_kpv_to_a = v; }
 set ring_kpv_goto_b (v) {    this.ring_kpv_to_b = v; }
 set hangup_status_a (v) {  this.hangup_from_a = v; }
 set hangup_status_b (v) {  this.hangup_from_b = v; }
 set ticket_status (v)   {  this.ticket_state=v; }
 set info(v)    {      this.client_info=v;  }
 set show_case(v)    {    this.showcase=v;  }

}


//wss.on('connection', function(ws){
////////////////////wss7


//////////////////////////
// обработчик входящих сообщений Asterisk
ws.on('open',function(){console.log('Connected to ARI');});
ws.on('error',function(e){console.log('ARI Connection error:',e);});
//ws.onmessage = function(event) {
ws.on('message',function(d,flags){
//wss.broadcast(event); 
//  var incomingMessage = event.data;
//  var incomingMessage = d.data;
//  var str = JSON.parse(event.data);
  var str = JSON.parse(d);
  var ep;

//////////////////////////////////  
//wss_broadcast(str);
 
//console.log(str);
/*
wss.on('connection', function connection(ws){ 

var id = Math.random;
clients[id]=ws;
console.log('New Connection' + id);

wss.onmessage('message', function(message){
 console.log('SERVER');
 
for(var key in clients){
clients[key].send(message);
}
  });

});
*/
//console.log(str);
////////////////////////////////
switch(str.type)
{
	
	
	case "StasisStart": 
//console.log(str);
	console.log('Stasis  start - Dialer');
	if(str.channel.dialplan.exten == ""){break;}
	
rnd = get_uid();
	
ticket_stasis[rnd] = new Ticket_Stasis(rnd,str.channel.id,str.channel.name,str.channel.caller.name,str.channel.caller.number,str.channel.dialplan.exten,str.args);
//	show_ticket(rnd);
ticket_stasis[rnd].show_case='StasisStart';

if(str.channel.dialplan.exten.startsWith('17')){
plus_bridge(ticket_stasis[rnd].ui); 
plus_ch_to_bridge(ticket_stasis[rnd].ui,str.channel.id)
go_to_endpoint('',str.channel.dialplan.exten,rnd);
}else{
////////////////////////Mysql req
var n = "'";
var n1 =n + '%' + ticket_stasis[rnd].cgn + '%' + n;
//n1 = n1 + "'"; 
//console.log('N1: ', n1);
//conn.query('SELECT * FROM info_clients where telephone_mobile_1  =' + ticket_stasis[rnd].cgn + ' OR telephone_number_1 =' + ticket_stasis[rnd].cgn
conn.query('SELECT * FROM info_clients where telephone_number_1  like ' + n1 +  ' OR telephone_mobile_1 like ' + n1
,function(error, result, fields){

ticket_stasis[rnd].info=result;
plus_bridge(ticket_stasis[rnd].ui); 
plus_ch_to_bridge(ticket_stasis[rnd].ui,str.channel.id);
play_to_ch(ticket_stasis[rnd].ch_a,ticket_stasis[rnd].playback_ch_a,MEDIA,SKIPMS);
ticket_stasis[rnd].show_case='StasisStart';
wss.broadcast(JSON.stringify(ticket_stasis[rnd]));
//ticket_stasis[rnd].info=null;
});	
/////////////////////////////END Mysql
}
	   break;
	
	case "Dial":
if(str.dialstatus == 'RINGING'){

//console.log(str);
ticket_stasis[str.peer.id].show_case='Dial_RING';
wss.broadcast(JSON.stringify(ticket_stasis[str.peer.id]));
break;
}
                                    
if(str.dialstatus == 'ANSWER'){ 
//console.log(str);
plus_ch_to_bridge(ticket_stasis[str.peer.id].ui,ticket_stasis[str.peer.id].ch_b);
ticket_stasis[str.peer.id].show_case='Dial_ANSWER';
console.log(ticket_stasis[str.peer.id].ep);
wss.broadcast(JSON.stringify(ticket_stasis[str.peer.id]));	
var fbr=get_date(ticket_stasis[str.peer.id].cgn,ticket_stasis[str.peer.id].ep) + '_br';
record_bridge(ticket_stasis[str.peer.id].ui,fbr,'wav');

	break;}
/*
//console.log(str);
*/
	
if(str.dialstatus == 'BUSY'){
//console.log(str);
}
	break;

case "ChannelEnteredBridge":  break;
	
	
case "ChannelConnectedLine":  break;
	

		
    case "ChannelHangupRequest":
ticket_stasis.some(function(item, index, array) {

if(ticket_stasis[index].ch_a == str.channel.id){
//console.log('From A');
if(ticket_stasis[index].show_case != 'StasisStart'){ 
minus_ch(ticket_stasis[index].ch_b,'normal');}
minus_bridge (ticket_stasis[index].ui);
ticket_stasis[index].ticket_status=false;
ticket_stasis[index].show_case='ChannelHangupRequest';
wss.broadcast(JSON.stringify(ticket_stasis[index]));
delete ticket_stasis[index];
return;
}
//------------------------
if(ticket_stasis[index].ch_b == str.channel.id){
//if(ticket_stasis[index].ch_a!=null){}
minus_ch(ticket_stasis[index].ch_a,'normal');
minus_bridge (ticket_stasis[index].ui);
ticket_stasis[index].ticket_status=false;
ticket_stasis[index].show_case='ChannelHangupRequest';
wss.broadcast(JSON.stringify(ticket_stasis[index]));
delete ticket_stasis[index];
return;
}

})
		
	break;
		
case	"ChannelLeftBridge":break;	     
	 
case "ChannelDestroyed":break;
	
case "PlaybackStarted":break;

case "PlaybackFinished":break;

case "StasisEnd":    break;

case "ChannelUserevent"://console.log(str);
if(str.eventname == 'Oper_Ready'){}
break;


    default:  // console.log(str);      // 


/*
    let k=0; 
ticket_stasis.forEach(function(item, index, array) {
k=k+1;
 
});
    
console.log('=====================COUNT ELEMENT of ARRAY ===',k);
*/
    // showMessage(str.channel.id);
///////////////////////////////


//////////////////////////////
}// end switch case
///////////////////////////////
//console.log(ticket_stasis[rnd]);
//wss.broadcast(JSON.parse(ticket_stasis[rnd]));
//wss.broadcast(d);
}); //ws end ws.onmessage
ws.on('error',function(e){console.log('ARI Connection error:',e);});

const sleep = (milliseconds) => {
  return new Promise(resolve => setTimeout(resolve, milliseconds))
}
//Example sleep
//sleep(2000).then(()=>{ //do function; })

//////////////////////////WSS
wss = new WebSocketServer({ port: WSS_PORT});
//});//wss connection
wss.broadcast = function broadcast(data) {
    wss.clients.forEach(function each(client) {
	if( client.readyState == 1 ){
	    client.send(data);
	}
    });
};

;

wss.on('connection', function connection(ws) {
////////////
ws.on('close', function connection(ws) {
//var c = JSON.parse(clients);
//console.log('WEB DisConnected',clients.id);
//console.log('WEB DisConnected',ws);

});
///////////
console.log('WEB Connected');

var id = Math.random();
  clients[id] = ws;
  console.log("новое соединение " + id);
 // console.log('WEB Connected');
 ws.on('message', function incoming(m){
 var mess = JSON.parse(m);
 console.log('Received: %s', m);
 console.log('Received: %s', mess.type);
 
 switch(mess.type){
 case  'HangUp': minus_ch(mess.channel_id,'normal'); break;
 case  'Come2me': 
 var j = {'variables':{'bridge':mess.bridge_id,'channel':mess.channel_id}};
// if(ticket_stasis[mess.channel_id].show_case =='Dial_ANSWER'){
 //event(mess.number_oper,'Oper_BUSY',j);
// break;}
 
 ticket_stasis[mess.channel_id].show_case=mess.channel_id;
 ticket_stasis[mess.channel_id].ep=mess.number_oper;
 del_play_to_ch(mess.channel_id + 4000);
//create_new_ch(mess.number_oper, '', APP_NAME,mess.channel_id, TIMER,FORMAT );
//var d = JSON.stringify({bridge:mess.bridge_id,channel:mess.channel_id});
go_to_oper(mess.number_oper,mess.channel_id);
//cr_event(mess.number_oper,mess.channel_id);
//event(mess.number_oper,'Oper_Ready',j);

        break;

case 'Reg': 

ticket_stasis.forEach(function(item, index, array) {
//k=k+1;
if(ticket_stasis[index].show_case !='_Dial_ANSWER'){  
wss.broadcast(JSON.stringify(ticket_stasis[index]));
 }
 
})


break;

default: break;

 }
// if(mess.type == 'HangUp' ){minus_ch(mess.channel_id,'normal'); }
 
 });

});

///////////////////////////////////////////////////////////////////////////////////////////////////////

//wss.on('connection', function connection(ws) {Console.log('WEB Connected');});

//////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////WSS

function get_date(cgn,cdn){
var d = new Date();

var s=d.getFullYear().toString();
var m=d.getMonth() + 1;
if(m < 10){ s = s + '0' + m.toString();}
else{s= s + m.toString();}

//s=s+d.getDate().toString();
var day=d.getDate();
if(day < 10){ days = s + '0' + day.toString();}
else{s= s + day.toString();}

//s=s+d.getHours();
var h =d.getHours(); 
if(h < 10){ s = s + '0' + h.toString();}
else{s= s + h.toString();}

var min =d.getMinutes();
if(min < 10){ s = s + '0' + min.toString();}
else{s= s + min.toString();} 
var sec=d.getSeconds().toString();
if(sec < 10){ s = s + '0' + sec.toString();}
else{s= s + sec.toString();} 
// + d.getMonth() + d.getDate() + d.getHours() + d.getMinutes() + d.getSeconds();
var a=cdn.split('/');
s = s + '_' + d.getMilliseconds();
s = s + '-' + cgn + '-' + a[1];
return s;
}



function get_uid(){
 var rnd2 = Math.floor(MIN + Math.random()*(MAX + 1 - MIN));

//console.log("LEN ticket array: ",ticket_stasis.length);
let cnt = 0;
let i =45;
while(i){
 
ticket_stasis.forEach((element, index, array) => {
if(ticket_stasis[index].ch_b == rnd2){cnt = cnt + 1;}

//cnt = cnt + 1;  

})

if(cnt == 0 ){rnd=rnd2; i=0;}
else{cnt=0;rnd2 = Math.floor(MIN + Math.random()*(MAX + 1 - MIN));}
}


//console.log("unicum == ",rnd );
rnd = rnd2;
return rnd2;
};


function event(ep,ev_name,v){
var url;
u = 'http://' + ARI_HOST + ':' + ARI_PORT;
u = u + '/ari/events/user/' + ev_name + '?application=' + APP_NAME;
u = u + '&source=endpoint:' + ep + '&api_key=' + API_KEY; 
request.post({
headers: {'content-type':'application/json'},
url:u,
body: v,
json:true
},
function (error, response, body) {
//            if (!error) {
                console.log( 'Create_event  Response Code:', response.statusCode );
                console.log( 'Create_event : ', ev_name );
//                }
            }

)
}


function cr_event(ep, ev_name){
var sts;
var url;
url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/events/user/' + ev_name + '?application=' + APP_NAME;
//url = url + '/ari/channels?endpoint=' + e  + '&context=' + cntxt;
//url = url + '&app=' + apps + '&channelId=' + ch_id;
url = url + '&source=endpoint:' + ep ;
//console.log('cr_ch',url);
request.post(  url,
//body: JSON.stringify({channel:245});
  {
form: {   'api_key': API_KEY,
         //  body:JSON.stringify( {bridge:'145'}),
 }

    },
//body=JSON.stringify({channel:245});
        function (error, response, body) {
    //      if (!error &&  response.statusCode != 204) {
            if (!error) {
  //        if (response.statusCode != 204) {
                console.log( 'Create_event  Response Code:', response.statusCode );
                console.log( 'Create_event : ', ev_name );
                }
            }
    )    
};



function cr_ch(e,  apps, ch_id, frmt='alaw%2Culaw'){
var sts;
var url;
url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/channels/create?endpoint=' + e;
//url = url + '/ari/channels?endpoint=' + e  + '&context=' + cntxt;
url = url + '&app=' + apps + '&channelId=' + ch_id;
url = url + '&formats=' + frmt;
console.log('cr_ch',url);
request.post(  url,  {form: {   'api_key': API_KEY,}    },
            function (error, response, body) {
        //      if (!error &&  response.statusCode != 204) {
                if (!error) {
        //        if (response.statusCode != 204) {
                console.log( 'Create_plus  channel Response Code:', response.statusCode );
                console.log( 'Create_plus  channel: ', ch_id );
                }
            }
        );
};



function create_new_ch(e, cntxt, apps, t=30, ch_id, frmt='alaw%2Culaw'){


//create channel
var sts;
var url;

url = 'http://' + ARI_HOST + ':' + ARI_PORT;
if(cntxt == ""){ url = url + '/ari/channels?endpoint=' + e; }
else{url = url + '/ari/channels?endpoint=' + e  + '&context=' + cntxt; }
url = url + '&app=' + apps + '&timeout=' + t + '&channelId=' + ch_id;
url = url + '&formats=' + frmt;

//console.log(url);

request.post(
                url,
	    {
		form: {
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, body) {
    	//	if (!error &&  response.statusCode != 204) {
    		if (!error) {
        	console.log( 'Create channel Response Code:', response.statusCode );
    		console.log( 'Create channel: ', ch_id );
    		}
	//	moh_manage( data );
	    }
	);
};
        	
        	
//Record channel
//http://192.168.88.25:8088/ari/channels/1000/record?name=test.wav&format=wav&ifExists=fail&terminateOn=none&api_key=ariuser:123
function record_ch(ch_id,name,frmt){


//create channel
var sts;
var url;

url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/channels/' + ch_id + '/record?name=' + name; 
//url = url + '&app=' + apps + '&timeout=' + t + '&channelId=' + ch_id;
//url = url + '&formats=' + frmt;

//console.log(url);

request.post(
                url,
	    {
		form: {
		    'format':frmt,
		    'ifExists':'fail',
		    'terminateOn':'none',
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, body) {
    		if (!error &&  response.statusCode != 204) {
        	console.log( 'Begin record channel Response Code:', response.statusCode );
    		console.log( 'Begin record channel: ', ch_id );
    		}
	//	moh_manage( data );
	    }
	);
};



function record_bridge(brd,name,frmt){


//create channel
var sts;
var url;

url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/bridges/' + brd + '/record?name=' + name; 
//url = url + '&app=' + apps + '&timeout=' + t + '&channelId=' + ch_id;
//url = url + '&formats=' + frmt;

//console.log(url);

request.post(
                url,
	    {
		form: {
		    'format':frmt,
		    'ifExists':'fail',
		    'terminateOn':'none',
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, body) {
    		if (!error &&  response.statusCode != 204) {
        	console.log( 'Begin record Bridge Response Code:', response.statusCode );
    		console.log( 'Begin record Bridge: ', brd );
    		}
	//	moh_manage( data );
	    }
	);
};


//http://192.168.88.25:8088/ari/channels/12312312312/snoop/34534534534?spy=none&whisper=none&app=dialer&api_key=ariuser:123
function snoop_ch(ch_id,snoop_id,app,spy,whisper){

//console.log( 'SNOOP',ch_id,snoop_id,app,spy,whisper); 

//create channel
var sts;
var url;

url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/channels/' + ch_id + '/snoop/' + snoop_id; 
url = url + '?spy=' + spy;// + '&whisper=' + whisper + '&app=' + app;
//url = url + '&formats=' + frmt;

//console.log(url);

request.post(
                url,
	    {
		form: {
                     
		    'whisper':whisper,
		    'app':app,
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, body) {
    	//	if (!error &&  response.statusCode != 204) {
    		if (!error) {
        	console.log( 'Snoop  channel Response Code:', response.statusCode );
    		console.log( 'Snoop  channel: ', ch_id );
    		}
	//	moh_manage( data );
	    }
	);
};


function go_to_oper(e,ch_id){
			
var url;
url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/channels?endpoint=' + e; 
url = url + '&app=' + APP_NAME + '&timeout=' + TIMER + '&channelId=' + ch_id;
url = url + '&formats=' + FORMAT;
request.post(url,  {form: {   'api_key': API_KEY,}   },
	        function (error, response, body) {
    		//var tmp = JSON.parse(body);
    		//console.log(tmp);
    		//if (!error  &&  response.statusCode != 204) {
    		if (!error) {
    		
        	console.log( 'Create channel Response code:', response.statusCode );
    		console.log( 'Create channel: ', ch_id );
//    		plus_ch_to_bridge(ch_id-100,ch_id );
    		}
	    }
	);
 
};



function go_to_endpoint(cntxt,exten,ch_id){
request.get(
    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/endpoints',
    {	form: { 'api_key': API_KEY, }	    },
	    function (error, response, b) {
            var p = {};
            var e;
	    console.log('Get endpoint Response code: ', response.statusCode );
	    
    		if ( !error &&  response.statusCode == 200) {
//console.log(response.body);
    	p=JSON.parse(response.body);
//    			console.log(p);
	let cnt =0;
	for( i=0; i < p.length; ++i){
			
		if(p[i].resource == exten){ cnt++; 
//	if(p[i].state == "online" ||  p[i].state == "unknown"){

	if(p[i].state == "online"   &&  p[i].channel_ids.length == 0){
	//	console.log('********',p[i].channel_ids.length );
                    e = p[i].technology + '/' + p[i].resource;
                    ticket_stasis[ch_id].ep=e;
console.log('Get endpoint:',  e);				
var url;
url = 'http://' + ARI_HOST + ':' + ARI_PORT;
if(cntxt == ""){ url = url + '/ari/channels?endpoint=' + e; }
else{url = url + '/ari/channels?endpoint=' + e  + '&context=' + cntxt; }
url = url + '&app=' + APP_NAME + '&timeout=' + TIMER + '&channelId=' + ch_id;
url = url + '&formats=' + FORMAT;
request.post(url,  {form: {   'api_key': API_KEY,}   },
	        function (error, response, body) {
    		//var tmp = JSON.parse(body);
    		//console.log(tmp);
    		if (!error  &&  response.statusCode != 204) {
        	console.log( 'Create channel Response code:', response.statusCode );
    		console.log( 'Create channel: ', ch_id );
    		}
	    }
	);
 }else{ 
minus_ch(ticket_stasis[ch_id].ch_a,'busy');
// play_to_ch(ticket_stasis[ch_id].ch_a,ticket_stasis[ch_id].playback_ch_a,MEDIA,SKIPMS);
// ticket_stasis[ch_id].cnt_try++;
 // ticket_stasis[ch_id].cnt_try=ticket_stasis[ch_id].cnt_try + 1;
// ticket_stasis[ch_id].cnt_try++;
// ticket_stasis[ch_id].show_case='Playback_Wait';
// wss.broadcast(JSON.stringify(ticket_stasis[ch_id]));
 } } }
if(cnt == 0 ){ 
minus_ch(ticket_stasis[ch_id].ch_a,'unallocated'); 
//ticket_stasis[ch_id].ch_a=null;
minus_bridge (ticket_stasis[ch_id].ui);
delete ticket_stasis[ch_id];
return; }
    		}
	//	moh_manage( data );
	    }
	);
};


function get_trunk(url, t,ch_id, callback){
request.post(url,  {form: {   'api_key': API_KEY,}   },
	    
	        function (error, response, body) {
    		if (!error && response.statusCode == 200) {	
        	console.log( 'Create Trunk ',t, ' channel Response code:', response.statusCode );
    		console.log( 'Create Trunk ',t, ' channel :', ch_id );
//    		callback(body);
    		callback(response.statusCode);
    		}else{console.log( 'Trunk :', t,' Error');  }
	    }
	    
	);
//	console.log('Response_____________', rsp);
	}

////////////// end Local Function


function go_to_trunk(exten,ch_id,trunks){
//console.log('params  :', trunks );
var t  = trunks.split(',');
////////////Cycle
var i =0;
var rsp;
//////Begin cycle
for(i=0;i<t.length;i++ ){
var url;
url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/channels?endpoint=' + t[i] + '/' + exten;
url = url + '&app=' + APP_NAME + '&timeout=' + TIMER + '&channelId=' + ch_id;
url = url + '&formats=' + FORMAT;   
//get_trunk(url,t[i],ch_id, function(d){if(d == 200){i=t.length; return i;}});
request.post(url,  {form: {   'api_key': API_KEY,}   },
	    
	        function (error, response, body) {
    		if (!error && response.statusCode == 200) {	
        	console.log( 'Create Trunk ',t, ' channel Response code:', response.statusCode );
    		console.log( 'Create Trunk ',t, ' channel :', ch_id );
//    		callback(body);
//    		callback(response.statusCode);
    		}else{console.log( 'Trunk :', t,' Error');  }
	    }
	);
	
}///////////////end Cycle	

};



//http://192.168.88.25:8088/ari/events/user/StasisEnd?application=dialer&api_key=ariuser:123
function my_event(event_name,app){
//console.log('params  :', trunks );
//var t  = trunks.split(','); 
//var url;
/*
url=0;
url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/channels?endpoint=' + t[0] + '/' + exten;
//else{url = url + '/ari/channels?endpoint=' +  t[0] + '/' + exten + '&context=' + cntxt; }
url = url + '&app=' + APP_NAME + '&timeout=' + TIMER + '&channelId=' + ch_id;
url = url + '&formats=' + FORMAT;
*/
////////////Cycle
//var i =0;
var rsp;
//for(i=0;i<t.length;i++ ){
//url ='';
let url;
//http://192.168.88.25:8088/ari/events/user/StasisEnd?application=dialer&api_key=ariuser:123
url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/events/user/' + event_name + '?application=' + app;
//url = url + '&app=' + APP_NAME + '&timeout=' + TIMER + '&channelId=' + ch_id;
//url = url + '&formats=' + FORMAT;   
request.post(url,  {form: {   'api_key': API_KEY,}   },
	    
	        function (error, response, body) {
    		//var tmp = JSON.parse(body);
    		//console.log(tmp);
    		if (!error) {
//    		if (!error && response.statusCode == 200) {	
//	console.log( 'stasis start. WS on message: ', b, ': ', response.statusCode );
        	console.log( 'My Event  Response code:', response.statusCode );
    		console.log( 'Event Name: ', event_name);
    		
    	//	i=t.length;
    	//	return response.statusCode;
    		}
	//	moh_manage( data );
//	    break;
	    }
	    
	);
//	console.log('Response_____________', rsp);
//	}
////////////////end Cycle	
	
};




function  minus_ch (ch,cause){


request.del(
		'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' + ch,
		{
		    form: {
		    reason:cause,
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
			    if (!error) {
			//    if (!error && response.statusCode != 204) {
//		console.log( ' WS on message: ', body, ': ', response.statusCode );	
				console.log('Delete channel Response code: ', response.statusCode);
				console.log('Delete channel : ', ch);
				//console.log('Delete channel Response : ', response.statusCode);
			    }
		}
	    );
 
// var url = 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' +  ch + '?api_key=' + API_KEY;

};



function  plus_bridge (brd){
//console.log('plus bridge');
request.post(
    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + brd,
	    {
		form: {
		type: 'mixing',
		name: brd,
         	'api_key': API_KEY,
		}
	    },
	    function (error, response, body) {
    		if ( !error) {
    	//	if ( !error && response.statusCode == 200) {	
//        	console.log( 'stasis start. WS on message: ', b, ': ', response.statusCode );
        	console.log( 'Create Bridge  Response code: ',':', response.statusCode );
    		console.log( 'Create Bridge: ', brd);
    		}
	//	moh_manage( data );
	    }
	);

};

function  minus_bridge (brd){

request.del(
		'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + brd,
		{
		    form: {
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
			    if (!error) {
			    //if (!error && response.statusCode != 204) {
			
//		console.log( ' WS on message: ', b, ': ', response.statusCode );	
				console.log('Delete Bridge Response code: ', response.statusCode);
				console.log('Delete Bridge : ', brd);
				
			    }
		}
	    );


 
// var url = 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' +  b + '?api_key=' + API_KEY;

};
	

function  plus_ch_to_bridge (brd, ch){

//console.log('plus ch to bridge',brd,'channel ', ch);
request.post(
    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + brd + '/addChannel?channel=' + ch,
	    {
		form: {
//		     channel: ch,
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, body) {
    		if (!error &&  response.statusCode != 200) {
//        	console.log( 'stasis start. WS on message: ', b, ': ', response.statusCode );
        	console.log( 'Add channel to Bridge Response code: ', response.statusCode );
    		console.log( 'Add channel to Bridge: ', ch, 'To' , brd)
    		}
	//	moh_manage( data );
	    }
	); 

};



function  minus_ch_from_bridge (brd, ch){

// var url = 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges?bridgeId=' + BRIDGE_ID + '&api_key=' + API_KEY;
// http://192.168.88.25:8088/ari/bridges/1451451451/addChannel?channel=ХХХ_IN_ХХХХХ.ХХХ&api_key=ariuser:123
//http://192.168.88.25:8088/ari/bridges/1451451451/removeChannel?channel=1571734363.523&api_key=ariuser:123


request.del(
 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + brd + '/removeChannel?channel=' + ch,
		{
		    form: {
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
			    if (!error && response.statusCode != 204) {
			
//		console.log( ' WS on message: ', b, ': ', response.statusCode );	
				console.log('Delete channel from Bridge  Response code : ', response.statusCode);
				console.log('Delete channel:', ch, ' from Bridge : ', brd);
				
			    }
		}
	    );


// var url = 'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/bridges/' + b + '/removeChannel?channel=' + ch + '&api_key=' + API_KEY;

    
};


function play_control(ch_play,operation){
//http://192.168.88.25:8088/ari/playbacks/6484121a-4b78-4851-9086-52c6dfac04a5/control?operation=reverse&api_key=ariuser:123

var url;

url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/playbacks/' + ch_play + 'control?operation=' + operation + '&api_key=' + API_KEY;
var p,sts;
/**/   
  var params = {}

var r = fetch(url, {
    method : "POST",
	headers: {  
      "Content-type": "application/json;"  
    },  
    body: JSON.stringify(params),
  
}).then(function(response) {
   return response.json();
  })
  .then(function(json) {
 })
  .catch(function(error) {
    log('Request failed', error)
  });


};

function play_to_ch(ch_id,ch_play,media, skipms=3000){
var url;

url = 'http://' + ARI_HOST + ':' + ARI_PORT;
url = url + '/ari/channels/' + ch_id + '/play/' + ch_play + '?media=' + media + '&skipms=' + skipms; 
//console.log('********* ',url);
request.post(
//    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' + ch_id + '/ring',
               url,
	    {
		form: {
 
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, b) {
    		if ( response.statusCode != 200) {
        //    	console.log( 'DIAL. WS on message: ', b, ': ', response.statusCode );
                               	console.log('PLay to channel Response code : ', response.statusCode);
                               	console.log('PLay', media, ' to :' , ch_id);
				
        
    		}
	//	moh_manage( data );
	    }
	);
//http://192.168.88.25:8088/ari/channels/1000000000/play/6960000000?media=sound%3Apaul_m&skipms=3000&api_key=ariuser:123 

  
};
        	
function del_play_to_ch(ch_id){
//http://192.168.88.25:8088/ari/channels/7777777777/ring?api_key=ariuser:123

request.del(
		'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/playbacks/' + ch_id ,
		{
		    form: {
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
		//	    if (!error && response.statusCode != 204) {
		if (!error) {
	//	console.log( 'DIAL. WS on message: ', b, ': ', response.statusCode );	
				console.log('Delete PLayback Response code : ', response.statusCode);
				console.log('Delete PLayback : ', ch_id);
				
			    }
		}
	    );

  
};





function ring_to_ch(ch_id){
request.post(
    'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' + ch_id + '/ring',
	    {
		form: {
 
		    'api_key': API_KEY,
		}
	    },
	    function (error, response, b) {
    		if ( response.statusCode != 200) {
            //	console.log( 'DIAL. WS on message: ', b, ': ', response.statusCode );
                               	
                               	console.log('RING Response code: ', response.statusCode);
                               	console.log('RING to channel: ', ch_id);
				
        
    		}
	//	moh_manage( data );
	    }
	);


//http://192.168.88.25:8088/ari/channels/7777777777/ring?api_key=ariuser:123
  
};


function del_ring_to_ch(ch_id){
//http://192.168.88.25:8088/ari/channels/7777777777/ring?api_key=ariuser:123

request.del(
		'http://' + ARI_HOST + ':' + ARI_PORT + '/ari/channels/' + ch_id + '/ring',
		{
		    form: {
		    'api_key': API_KEY,
		    },
		},
		function (error, response, body) {
			    if (!error && response.statusCode != 204) {
		
	//	console.log( 'DIAL. WS on message: ', b, ': ', response.statusCode );	
				console.log('Delete RING Response code : ', response.statusCode);
				console.log('Delete RING : ', ch_id);
				
			    }
		}
	    );

  
};

/////////////////////////Mysql
function get_clients (num){
var res;
conn.query('SELECT * FROM info_clients where telephone_number_1 or telephone_mobile_1 like %num%',
 function(error, result, fields){

    console.log(result);
    console.log(result[1].name);
//wss.broadcast(JSON.stringify(ticket_stasis[index]));
wss.broadcast(result);

//    res=result;
//return result;

})
//return res;
};

//conn.query('select * ' );


/*
// закрытие подключения
 conn.end(function(err) {
  if (err) {
    return console.log("Ошибка: " + err.message);
  }
  console.log("Подключение закрыто");
});
//немедленное закрытие
conn.destroy()
*/





